
#include<bobpp/thr/thr.h>


namespace  Bob {


Thread *ThrEnvProg::tt=0;
int ThrEnvProg::nbth=0;
bool ThrEnvProg::multi_inst=false;

void *GoThread(void *a) {
   Thread *t=(Thread *)a;

   t->loop();
   return 0;
}

Thread::Thread() : a(0),bar(0),state(ThWait) { 
   pthread_cond_init(&cond,0);
   pthread_mutex_init(&mut,0); 
   pthread_attr_init(&attr);
   pthread_attr_setstacksize(&attr,ThrEnvProg::stack_size());
   pthread_create(&id,&attr,GoThread,(void *)this);
}


void Thread::loop() {
      //std::cout<< pthread_self() <<": Starting in Loop\n";
      pthread_mutex_lock(&mut);
      if ( state==ThWait )  {
         //std::cout << pthread_self() <<": Wait\n";
         pthread_cond_wait(&cond,&mut);
         pthread_mutex_unlock(&mut);
      } else
         pthread_mutex_unlock(&mut);
      while ( state!=ThStop ) {
          if (state==ThHasWork ) {
             BOBASSERT(a!=0,StateException,"Thread::loop()","Thread get work but pointer is null !");
             std::cout << pthread_self()<< "r:"<<ThrEnvProg::rank()<<": Run\n";
             pthread_mutex_lock(&mut);
             state=ThWork;
             pthread_mutex_unlock(&mut);
             (*a)();
             pthread_mutex_lock(&mut);
             if ( state==ThWork) { a=0; state=ThWait;}
             pthread_mutex_unlock(&mut);
             std::cout << pthread_self()<< "r:"<<ThrEnvProg::rank()<<": Algo Finish \n";
             bar->Wait();

          }
          std::cout << pthread_self()<< "r:"<<ThrEnvProg::rank()<<": Re Wait\n";
          pthread_mutex_lock(&mut);
          if ( state==ThStop ) {
              pthread_mutex_unlock(&mut);
              break;
          }
          if ( state==ThHasWork ) { 
              pthread_mutex_unlock(&mut);
              continue;
          }
          state = ThWait;
          pthread_cond_wait(&cond,&mut);
          pthread_mutex_unlock(&mut);
      }
      std::cout << pthread_self()<< "r:"<<ThrEnvProg::rank()<< ": Exit of Loop\n";
}

long ThrId::id() {
   return (long)ThrEnvProg::rank();
}
long ThrId::nb() {
   return (long)ThrEnvProg::nthread();
}


};
